﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="WebTreeBind.Default" %>

<%@ Register assembly="Infragistics4.Web.v11.1, Version=11.1.20111.1006, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" namespace="Infragistics.Web.UI" tagprefix="ig" %>
<%@ Register assembly="Infragistics4.WebUI.UltraWebNavigator.v11.1, Version=11.1.20111.1006, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" namespace="Infragistics.WebUI.UltraWebNavigator" tagprefix="ignav" %>
<%@ Register assembly="Infragistics4.Web.v11.1, Version=11.1.20111.1006, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb" namespace="Infragistics.Web.UI.LayoutControls" tagprefix="ig" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script type="text/javascript" id="igClientScript">
<!--

function UltraWebTree1_DragStart(oTree, oNode, oDataTransfer, oEvent){
    //Add code to handle your event here.
    oDataTransfer.dataTransfer.setData("Text", oNode.getText());
    oDataTransfer.dataTransfer.effectAllowed = "move";

}

function UltraWebTree1_Drop(oTree, oNode, oDataTransfer, oEvent){
    var droppingNode = oDataTransfer.sourceObject;
			
	if(droppingNode == null)
		return;

	if ((IsChildOf(droppingNode, oNode) == false) && (IsParentOf(oNode, droppingNode) == false)) {
		AddChildNodesRecursive(droppingNode, oNode);
	} else {
		alert("You can't add a node to its parent, grandparent, child, grandchild, etc. without creating an infinite loop.");
	}


}

function UltraWebTree2_DragStart(oTree, oNode, oDataTransfer, oEvent){
    //Add code to handle your event here.
    oDataTransfer.dataTransfer.setData("Text", oNode.getText());
    oDataTransfer.dataTransfer.effectAllowed = "move";

}

function UltraWebTree2_Drop(oTree, oNode, oDataTransfer, oEvent){
	var droppingNode = oDataTransfer.sourceObject;
			
	if(droppingNode == null)
		return;

	if ((IsChildOf(droppingNode, oNode) == false) && (IsParentOf(oNode, droppingNode) == false)) {
		AddChildNodesRecursive(droppingNode, oNode);
	} else {
		alert("You can't add a node to its parent, grandparent, child, grandchild, etc. without creating an infinite loop.");
	}

}

function AddChildNodesRecursive(childNode, parentNode) {
    var newChildNode
	if (parentNode == null)
	{
		var tree = igtree_getTreeById(childNode.getTreeId());
		newChildNode = tree.addRoot(childNode.getText());
	}
	else
		newChildNode = parentNode.addChild(childNode.getText());

	if (childNode.hasChildren()) {
		var children = childNode.getChildNodes();
		for (c in children) {
			var childSubNode = children[c];
			AddChildNodesRecursive(childSubNode, newChildNode);
		}
	}
	childNode.remove();
}

function IsParentOf(childNode, parentNode) {
	if (childNode != null)
	{
		if (childNode.getParent() == parentNode) {
			return true;
		} else if (childNode.getParent() != null) {
			return IsParentOf(childNode.getParent(), parentNode);
		}
	}
	return false;
}

function IsChildOf(childNode, parentNode) {
	if (parentNode != null)
	{
		if (parentNode.hasChildren()) {
			var children = parentNode.getChildNodes();
				for (c in children) {
				var currentChild = children[c];
				if (currentChild == childNode) {
					return true;
				} else if (currentChild.hasChildren()) {
					if (IsChildOf(childNode, currentChild)) {
						return true;
					} 
				}
			}
		}
	}
	return false;
}

// -->
</script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
    
    </div>
    <ignav:UltraWebTree ID="UltraWebTree1" runat="server" AllowDrag="True" 
        AllowDrop="True" DataSourceID="XmlDataSource1" DefaultImage="" HiliteClass="" 
        HoverClass="" Indentation="20">
        <ClientSideEvents DragStart="UltraWebTree1_DragStart" 
            Drop="UltraWebTree1_Drop" />
        <DataBindings>
            <ignav:NodeBinding DataMember="Customer" TextField="CustomerName" />
            <ignav:NodeBinding DataMember="Order" TextField="OrderID" />
            <ignav:NodeBinding DataMember="OrderDetail" TextField="ProductName" />
        </DataBindings>
    </ignav:UltraWebTree>
    <asp:XmlDataSource ID="XmlDataSource1" runat="server" DataFile="~/Orders2.xml">
    </asp:XmlDataSource>
    <asp:XmlDataSource ID="XmlDataSource2" runat="server" DataFile="~/Orders.xml">
    </asp:XmlDataSource>
    <ignav:UltraWebTree ID="UltraWebTree2" runat="server" AllowDrag="True" 
        AllowDrop="True" DataSourceID="XmlDataSource2" DefaultImage="" HiliteClass="" 
        HoverClass="" Indentation="20">
        <ClientSideEvents DragStart="UltraWebTree2_DragStart" 
            Drop="UltraWebTree2_Drop" />
        <DataBindings>
            <ignav:NodeBinding DataMember="Customer" TextField="CustomerName" />
            <ignav:NodeBinding DataMember="Order" TextField="OrderID" />
            <ignav:NodeBinding DataMember="OrderDetail" TextField="ProductName" />
        </DataBindings>
    </ignav:UltraWebTree>
    </form>
</body>
</html>
